% Objective is to load an image and produce another image that 
% shows the edges of obejcts in the image. Using a 
% Sobel edge detector, we can use this to find the edges in a sample
% image of a table and a chair. 

%First we must load the image
table = imread('IMG_2676.jpg'); 

%Then we can convert the image to grayscale. Could be 
%completed in RBG scale, but is easier in grayscale

table_gray = rgb2gray(table);

%Present grayscale image
figure
imshow(table_gray); 
title('grayscale image')

%Apply average filter to image to smooth out the picture
avg_filter = [1 2 1; 2 4 2; 1 2 1]/16; 
avg = imfilter(table_gray, avg_filter); 
figure
imshow(avg);
title('averaged filter')

%Find the edges in the smoothed picture
figure
blurred_edges = edge(avg, 'sobel'); 
imshow(blurred_edges);
title('Edge Detection for Smoothed Picture')

%Find the edges in the original picture
figure
edges = edge(table_gray, 'sobel'); 
imshow(edges);
title('Edge Detection for Original Picture')

%Show the horizontal aspects of the image 
figure
sobel_x = edge(table_gray, 'sobel', 'vertical'); 
imshow(sobel_x);
title('Sobel X Direction')

%Show the vertical aspects of the image 
figure
sobel_y = edge(table_gray, 'sobel', 'horizontal'); 
imshow(sobel_y);
title('Sobel Y Direction')

%Help received from: 
%M., ?Documentation,? Detecting a Cell Using Image Segmentation - MATLAB & Simulink Example. [Online]. Available: https://www.mathworks.com/help/images/examples/detecting-a-cell-using-image-segmentation.html. [Accessed: 23-Apr-2017].

